<?php
/******************************************************************************

  Create Universe Script
                       
  ChangeLog                                           
   Nov 2, 01 - Wandrer - Rewritten mostly from scratch
   March 2004 - Kestrel (gamemaster@spencerboys.net) 
    - rearranged steps into functions, 
    - added use of $_POST, script now requires PHP 4.1.0 or greater
    - added $DEBUG and $TIMER booleans, set in config.php
    - creates exactly the number of sectors requested instead of 1 extra
    - modified SQL used to initialize fedsectors, and ports
    - added error checking to some of the db calls (others already had it)
    - fixed planet creation so the correct number of planets are created
      (see comments in function place_planets() )
    - there was no step 6 so split step 5
    - HTML changes:
          includes/admin_header.php
          includes/admin_footer.php
          admin_header.php uses bnt_style.css
 
******************************************************************************/

//error_reporting(E_WARNING);

require_once("config_local.php");
require_once("config.php");

// is the language file needed for this script?
global $bnt_global;
require_once('languages/'.$default_lang.'.inc');

// default values are defined in config.php
// declaring all these globals is not strictly necessary, 
// but done for documentation purposes
global $adminpass, $sector_max, $fedsecs, $loops, $nump;
global $sched_apocalypse, $sched_counter, $sched_degrade, $sched_IGB;
global $sched_news, $sched_planets, $sched_playerinfo, $sched_ports;
global $sched_ranking, $sched_res, $sched_ticks, $sched_turns;
global $admin_mail, $maxlen_password;
global $start_armour, $start_credits, $start_energy, $start_fighters, $start_turns;
global $default_lang;

global $DEBUG; 
global $TIMER;

if ($TIMER) {
  include('includes/class_timer.php');
  //--- Start Timer
  $BenchmarkTimer = new c_Timer;
  $BenchmarkTimer->start();
}

//--- Set timelimit and randomize timer.
set_time_limit(0);
srand((double)microtime()*1000000);

//--- Include config files and db scheme.
require_once("includes/schema.php");

// Update cookie.
// 3/8/04 - Kestrel: what's the cookie for? Everything is passed in hidden fields.
//updatecookie();

// Start the output
include("includes/admin_header.php");
$title="Create Universe";

connectdb();
bigtitle();

if ( ($_POST['swordfish'] == $adminpass) && (isset($_POST['step']) ) ) {
    $step = $_POST['step'];
} else {
    $step = 0;
}

// Main switch statement.
switch ($step) {
case "1":
    // display form to get user's choices for universe
    // value for $sector_max comes from config.php
    echo "<p>Step 1: Enter Universe Parameters</p>\n";
    get_input($sector_max);
    break;
    
case "2":
    // $sektors is user's input from step 1
    echo "<p>Step 2: Confirm your input</p>\n";
    $sector_max = round($_POST['sektors']);
    if($fedsecs > $sector_max) {
        echo "The number of Federation sectors must be smaller than the size of the universe!";
    } else {
        confirm_input();
    }
    break;
    
case "3":
    echo "<p>Step 3. Drop and create tables. Create Sectors.</p>\n";
    create_schema();
    continue_to_next_step(4);
    break;
    
case "4":
    echo "<p>Step 4.</p>\n";
    if (create_sectors() == false) {
        echo "Create sectors failed. Unable to continue<br />\n";
        break;
    }
    if (define_zones() == false) {
        echo "Unable to continue<br />\n";
        break;
    }
    
    $port_type = 'special';
    $zone_id = 3;
    $number_ports = $_POST['spp'];
    if (create_ports($port_type, $zone_id, $number_ports) == false) {
        echo "Failed to create $port_type ports. Unable to continue<br />\n";
        break;
    }
    
    $port_type = 'ore';
    $zone_id = 1;
    $number_ports = $_POST['oep'];
    if (create_ports($port_type, $zone_id, $number_ports) == false) {
        echo "Failed to create $port_type ports. Unable to continue<br />\n";
        break;
    }
    
    $port_type = 'organics';
    $zone_id = 1;
    $number_ports = $_POST['ogp'];
    if (create_ports($port_type, $zone_id, $number_ports) == false) {
        echo "Failed to create $port_type ports. Unable to continue<br />\n";
        break;
    }
    
    $port_type = 'goods';
    $zone_id = 1;
    $number_ports = $_POST['gop'];
    if (create_ports($port_type, $zone_id, $number_ports) == false) {
        echo "Failed to create $port_type ports. Unable to continue<br />\n";
        break;
    }
    
    $port_type = 'energy';
    $zone_id = 1;
    $number_ports = $_POST['enp'];
    if (create_ports($port_type, $zone_id, $number_ports) == false) {
        echo "Failed to create $port_type ports. Unable to continue<br />\n";
        break;
    }
    
    if (create_fedsectors() == false) {
        echo "Unable to continue<br />\n";
        break;
    }

    if (stock_ports() == false) {
        echo "Failed to stock ports. Unable to continue<br />\n";
        break;
    }
    
    continue_to_next_step(5);
    break;
    
case "5":
    echo "<p>Step 5.</p>\n";
    
    if (place_planets() == false) {
        echo "Failed to place planets. Unable to continue<br />\n";
        break;
    }
    continue_to_next_step(6);
    break;
    
case "6":
    echo "<p>Step 6.</p>\n";
    if (create_warp_links() == false) {
        echo "Failed to create warp links. Unable to continue<br />\n";
        break;
    }
   if (create_random_warp_links() == false) {
        echo "Failed to create random warp links. Unable to continue<br />\n";
        break;
    }
    continue_to_next_step(7);
    break;
    
case "7":
    echo "<p>Step 7.</p>\n";
    if (configure_scheduler() == false) {
        echo "Failed to configure scheduler. Unable to continue<br />\n";
        break;
    }
    if (setup_admin_account() == false) {
        echo "Failed to setup admin account. Unable to continue<br />\n";
        break;
    }
    echo '
    <p><br /><br /><b>Congratulations! Universe created successfully.</b><br />
    <form method="GET" action="http://'. $gameURL .'/login.php">
    <input class="bttn" type="Submit" Name="submit" value="Login">
    </form>
    </p>
    ';
    break;
    
default:
    echo "<p>Step 0: Enter Admin Password</p>\n";
    get_password();
    break;
}

include("includes/admin_footer.php");
if ($TIMER) {
    $StopTime=$BenchmarkTimer->stop();
    $Elapsed=$BenchmarkTimer->elapsed();
    PrintFlush("<br />Elapsed Time - $Elapsed");
}

if ($DEBUG) {
    echo '<pre>';
    print_r($_POST);
    echo '</pre>';
}

exit;
/*------------------ end main --------------------*/

/*
##############################################################################
# Define Functions for this script                                           #
##############################################################################
*/

### Description: Create Benchmark Class

class c_Timer {
   var $t_start = 0;
   var $t_stop = 0;
   var $t_elapsed = 0;

   function start() { $this->t_start = microtime(); }
   function stop()  { $this->t_stop  = microtime(); }
   function elapsed() {
      $start_u = substr($this->t_start,0,10); $start_s = substr($this->t_start,11,10);
      $stop_u  = substr($this->t_stop,0,10);  $stop_s  = substr($this->t_stop,11,10);
      $start_total = doubleval($start_u) + $start_s;
      $stop_total  = doubleval($stop_u) + $stop_s;
      $this->t_elapsed = $stop_total - $start_total;
      return $this->t_elapsed;
   }
}

function PrintFlush($Text="") {
  print "$Text";
  // flush();    // need this only for debugging, otherwise it just slows things down
}

function get_password() 
{
  echo '
  <form action="'. $_SERVER['PHP_SELF'] .'" method="post">
  Password: <input type="password" name="swordfish" size="20" maxlength="20">&nbsp;&nbsp;
  <input type="hidden" name="step" value="1">
  <input type="submit" value="Submit" class="bttn">&nbsp;
  <input type="reset" value="Reset" class="bttn">
  </form>
  ';

}

/**
 * @return void
 * @param int $sector_max
 * @param string $swordfish
 * @desc Displays universe creation form. 
 *   $sector_max is initialized in config.php
 *   $swordfish if the local admin password 
 *   that was entered in order to run the script.    
*/
function get_input($sector_max)
{
    $fedsecs = intval($sector_max / 200);
    $loops = intval($sector_max / 500);
	
	echo '
	 <form action="'. $_SERVER['PHP_SELF'] .'" method="post">
   <table>
   <tr>
	   <td><b><u>Base/Planet Setup</u></b></td>
	   <td>&nbsp;</td>
   </tr>
   <tr>
	   <td>Percent Special</td>
	   <td><input type=text name=special size=5 maxlength=5 value=1></td>
	 </tr>
   <tr>
	    <td>Percent Ore</td>
	    <td><input type=text name=ore size=5 maxlength=5 value=15></td>
	 </tr>
   <tr>
	    <td>Percent Organics</td>
	    <td><input type=text name=organics size=5 maxlength=5 value=10></td>
	 </tr>
   <tr>
	   <td>Percent Goods</td>
	   <td><input type=text name=goods size=5 maxlength=5 value=15></td>
	 </tr>
   <tr>
	   <td>Percent Energy</td>
	   <td><input type=text name=energy size=5 maxlength=5 value=10></td>
	 </tr>
   <tr>
	   <td>Percent Empty</td>
	   <td>Equal to 100 - total of above.</td>
	 </tr>
   <tr>
	   <td>Initial Commodities to Sell<br /><td>
	   <input type=text name=initscommod size=6 maxlength=6 value=100.00> % of max</td>
	 </tr>
   <tr>
	   <td>Initial Commodities to Buy<br /><td>
	   <input type=text name=initbcommod size=6 maxlength=6 value=100.00> % of max</td>
	 </tr>
   <tr>
	   <td><b><u>Sector/Link Setup</u></b></td>
	   <td>&nbsp;</td>
	 </tr>
	 <tr>
	    <td>Number of sectors total (<b>overrides config.php</b>)</td>
	    <td><input type=text name=sektors size=5 maxlength=5 value="'.$sector_max.'"></td>
	 </tr>
   <tr>
	   <td>Number of Federation sectors</td>
	   <td><input type=text name=fedsecs size=5 maxlength=5 value="'.$fedsecs.'"></td>
	 </tr>
   <tr>
	   <td>Number of loops</td>
	   <td><input type=text name=loops size=5 maxlength=5 value="'.$loops.'"></td>
	 </tr>
   <tr>
	   <td>Percent of sectors with unowned planets</td>
	   <td><input type=text name=planets size=5 maxlength=5 value=10></td>
	 </tr>
   <tr>
	   <td>&nbsp;</td>
	   <td>
	      <input type=hidden name=engage value=1>
	      <input type=hidden name=step value=2>
	      <input type=hidden name=swordfish value="'.$_POST['swordfish'].'">
	      <input type=submit value=Submit class="bttn">
	      <input type=reset value=Reset class="bttn">
	   </td>
	 </tr>
   </table>
   </form>
	 ';
}

function confirm_input()
{
    $sector_max = $_POST['sektors'];
    $special = $_POST['special'];
    $ore = $_POST['ore'];
    $organics = $_POST['organics'];
    $goods = $_POST['goods'];
    $energy = $_POST['energy'];
    $planets = $_POST['planets'];
    $initscommod = $_POST['initscommod'];
    $initbcommod = $_POST['initbcommod'];
    
    $spp = round($sector_max*$special/100);
    $oep = round($sector_max*$ore/100);
    $ogp = round($sector_max*$organics/100);
    $gop = round($sector_max*$goods/100);
    $enp = round($sector_max*$energy/100);
    $empty = $sector_max-$spp-$oep-$ogp-$gop-$enp;
    $nump = round ($sector_max*$planets/100);
    echo '
      So you would like your universe to have:<br /><br />
      '.$sector_max.' sectors<br />
      '.$spp.' special ports<br />
      '.$oep.' ore ports<br />
      '.$ogp.' organics ports<br />
      '.$gop.' goods ports<br />
      '.$enp.' energy ports<br />
      '.$initscommod.'% initial commodities to sell<br />
      '.$initbcommod.'% initial commodities to buy<br />
      '.$empty.' empty sectors<br />
      '.$_POST['fedsecs'].' Federation sectors<br />
      '.$_POST['loops'].' loops<br />
      '.$nump.' unowned planets<br /><br />
      If this is correct, click confirm - otherwise go back.<br />
      <form action="'.$_SERVER['PHP_SELF'].'" method=post>
      <input type=hidden name=step value=3>
      <input type="hidden" name="sector_max" value="'.$sector_max.'">
      <input type=hidden name=spp value='.$spp.'>
      <input type=hidden name=oep value='.$oep.'>
      <input type=hidden name=ogp value='.$ogp.'>
      <input type=hidden name=gop value='.$gop.'>
      <input type=hidden name=enp value='.$enp.'>
      <input type=hidden name=initscommod value='.$initscommod.'>
      <input type=hidden name=initbcommod value='.$initbcommod.'>
      <input type=hidden name=nump value='.$nump.'>
      <input type=hidden name=fedsecs VALUE='.$_POST['fedsecs'].'>
      <input type=hidden name=loops value='.$_POST['loops'].'>
      <input type=hidden name=engage value=2>
      <input type=hidden name=swordfish value='.$_POST['swordfish'].'>
      <input type=submit value=Confirm class="bttn">
      </form>
      <p class="warning">WARNING: All tables will be DROPPED and the game will be RESET when you click <b>CONFIRM</b>!</p>
    ';
    
}

function continue_to_next_step($next_step=0) 
{
    global $sector_max;
    if (isset($_POST['sektors']) ) {
        $sector_max = $_POST['sektors'];
    }
    if (isset($_POST['sector_max']) ) {
        $sector_max = $_POST['sector_max'];
    }    
    echo '
      <form action="'.$_SERVER['PHP_SELF'].'" method=post>
      <input type="hidden" name="step" value="'.$next_step.'">
      <input type="hidden" name="sector_max" value="'.$sector_max.'">
      <input type="hidden" name="spp" value='.$_POST['spp'].'>
      <input type="hidden" name="oep" value='.$_POST['oep'].'>
      <input type="hidden" name="ogp" value='.$_POST['ogp'].'>
      <input type="hidden" name="gop" value='.$_POST['gop'].'>
      <input type="hidden" name="enp" value='.$_POST['enp'].'>
      <input type="hidden" name="initscommod" value='.$_POST['initscommod'].'>
      <input type="hidden" name="initbcommod" value='.$_POST['initbcommod'].'>
      <input type="hidden" name="nump" value='.$_POST['nump'].'>
      <input type="hidden" name="fedsecs" value='.$_POST['fedsecs'].'>
      <input type="hidden" name="loops" value='.$_POST['loops'].'>
      <input type="hidden" name="swordfish" value='.$_POST['swordfish'].'>
      <input type="submit" value="Continue" class="bttn">
      </form>
    ';
}


function create_sectors()
{
    global $db, $dbtables, $universe_size;
    $sector_max = $_POST['sector_max'];
    
    echo "Creating sector 0 - Sol ";
    $sql = "INSERT INTO $dbtables[universe] (sector_id, sector_name, zone_id, port_type, port_organics, port_ore, port_goods, port_energy, beacon, angle1, angle2, distance) VALUES ('0', 'Sol', '1', 'special', '0', '0', '0', '0', 'Sol: Hub of the Universe', '0', '0', '0')";
    if ($db->Execute($sql) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $sql<br />";
        return false;
    } else {
        echo "- completed successfully.<br />";
    }
    
    echo "Changing id for Sol ";
    $sql = "UPDATE {$dbtables['universe']} SET sector_id=0 WHERE sector_id=1";
    if ($db->Execute($sql) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $sql<br />";
        return false;
    } else {
        echo "- completed successfully.<br />";
    }
    
    echo "Creating sector 1 - Alpha Centauri "; // always an energy port - fill it later
    $sql = "INSERT INTO {$dbtables['universe']} 
               (sector_id, sector_name, zone_id, port_type, port_organics, port_ore, 
                port_goods, port_energy, beacon, angle1, angle2, distance) 
            VALUES ('1', 'Alpha Centauri', '1', 'energy',  '0', '0', '0', '0', 
                    'Alpha Centauri: Gateway to the Galaxy', '0', '0', '1')";
    
    if ($db->Execute($sql) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $sql<br />";
        return false;
    } else {
        echo "- completed successfully.<br />";
    }
    
    // Cycle through remaining sectors.
    // We are going to split the amount into groups of 500 and 
    // bulk pass the INSERTS to mysql at one time.
    $remaining = $sector_max-2;
    $batch = 500;
    echo "Creating remaining $remaining sectors in batches of $batch<br />";
    for ($i=2; $i<=$remaining; $i=$i+$batch) {
        
        if (($sector_max - $i) < $batch) {
            $end = $sector_max - $i;
        } else {
            $end = $batch;
        }
        
        // build the SQL
        $sql = "INSERT INTO {$dbtables['universe']} 
                (sector_id,zone_id,angle1,angle2,distance) VALUES ";
        for ($j=1; $j<$end; $j++) {
            $distance=intval(rand(1,$universe_size));
            $angle1=rand(0,180);
            $angle2=rand(0,90);
            $sql .= "('','1',$angle1,$angle2,$distance),";
        }
        // add last one outside the look so we don't add an extra comma
        $distance=intval(rand(1,$universe_size));
        $angle1=rand(0,180);
        $angle2=rand(0,90);
        $sql .= "('','1',$angle1,$angle2,$distance)";
        
        ### Now lets post the information to the mysql database.
        //echo "Inserting $j records<br />";
        if ($db->Execute($sql) == false) {
            echo "\nError: ".$db->ErrorMsg().'<br />';
            echo "SQL: $sql<br />";
            return false;
        } else {
            echo "Added $j sectors successfully.<br />\n";
        }
        
    }
    
    return true;
}

function define_zones()
{
    global $db;
    global $dbtables;
    global $fed_max_hull; // defined in config.php
    
    echo "Adding Zones";
    $sql[] = "REPLACE INTO {$dbtables['zones']} (zone_id, zone_name, owner, corp_zone, allow_beacon, allow_attack, allow_planetattack, allow_warpedit, allow_planet, allow_trade, allow_defenses, max_hull) VALUES ('1', 'Unchartered space', 0, 'N', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', '0' )";
    $sql[] = "REPLACE INTO {$dbtables['zones']} (zone_id, zone_name, owner, corp_zone, allow_beacon, allow_attack, allow_planetattack, allow_warpedit, allow_planet, allow_trade, allow_defenses, max_hull) VALUES ('2', 'Federation space', 0, 'N', 'N', 'N', 'N', 'N', 'N',  'Y', 'N', '$fed_max_hull')";
    $sql[] = "REPLACE INTO {$dbtables['zones']} (zone_id, zone_name, owner, corp_zone, allow_beacon, allow_attack, allow_planetattack, allow_warpedit, allow_planet, allow_trade, allow_defenses, max_hull) VALUES ('3', 'Free-Trade space', 0, 'N', 'N', 'Y', 'N', 'N', 'N','Y', 'N', '0')";
    $sql[] = "REPLACE INTO {$dbtables['zones']} (zone_id, zone_name, owner, corp_zone, allow_beacon, allow_attack, allow_planetattack, allow_warpedit, allow_planet, allow_trade, allow_defenses, max_hull) VALUES ('4', 'War Zone', 0, 'N', 'Y', 'Y', 'Y', 'Y', 'Y','N', 'Y', '0')";
    for ($i=0; $i<4; $i++) {
        if ($db->Execute($sql[$i]) == false) {
            echo 'error adding zone: '.$db->ErrorMsg().'<br />';
            echo "SQL: {$sql[$i]}<br />";
            return false;
        }
    }
    echo " - completed sucessfully<br />\n";
    return true;
}

function create_fedsectors()
{
    global $db;
    global $dbtables;
    
    $fedsecs = $_POST['fedsecs'];
    echo "Selecting $fedsecs Federation sectors ";
    $sql = "UPDATE {$dbtables['universe']} SET zone_id='2' WHERE sector_id<$fedsecs";
    if ($db->Execute($sql) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $sql<br />";
        return false;
    }
    echo "- completed successfully.<br />";
    return true;
}

function create_ports($port_type = '', $zone_id = 0, $number_ports = 0)
{
    global $db;
    global $dbtables;
    
    echo "Selecting $number_ports sectors for additional special ports ";
    // Note: the syntax below is in CVS but it doesn't work - no sector_ids are returned.
    // $sql_query=$db->Execute("SELECT sector_id FROM {$dbtables['universe']} WHERE port_type='none' AND RAND() ORDER BY RAND() DESC LIMIT $number_ports");
    // get list of sector ids
    $sql_query=$db->Execute("SELECT sector_id FROM {$dbtables['universe']} WHERE port_type='none' ORDER BY RAND(unix_timestamp()) DESC LIMIT $number_ports");
    if($sql_query)
    {
        while (!$sql_query->EOF) {
            $result = $sql_query->fields;
            $sectors[] = $result['sector_id'];
            $sql_query->MoveNext();
        }
        
        // update the selected sectors
        $sector_list = join(',', $sectors);
        $update = "UPDATE $dbtables[universe] SET zone_id='$zone_id',port_type='$port_type'
               WHERE port_type='none' 
               AND sector_id IN ($sector_list)";
        
        //echo "UPDATE SQL: $update<br />";
        
        if ($db->Execute($update) == false) {
            echo "\nError: ".$db->ErrorMsg().'<br />';
            echo "SQL: $update<br />";
            return false;
        }
        echo "- completed successfully. <br />";
        
    } else {
        echo "Problem with query, can't select sectors<br />";
        return false;
    }
    
    return true;
}

function stock_ports()
{
    global $db, $dbtables;
    global $ore_limit, $organics_limit, $goods_limit, $energy_limit; // values from config.php
    
    $sell_ore = $ore_limit * $_POST['initscommod'] / 100.0;
    $sell_organics = $organics_limit * $_POST['initscommod'] / 100.0;
    $sell_goods = $goods_limit * $_POST['initscommod'] / 100.0;
    $sell_energy = $energy_limit * $_POST['initscommod'] / 100.0;
    $buy_ore = $ore_limit * $_POST['initbcommod'] / 100.0;
    $buy_organics = $organics_limit * $_POST['initbcommod'] / 100.0;
    $buy_goods = $goods_limit * $_POST['initbcommod'] / 100.0;
    $buy_energy = $energy_limit * $_POST['initbcommod'] / 100.0;
    
    echo 'Stocking the Ore ports ';
    $update="UPDATE {$dbtables['universe']} SET port_ore=$sell_ore,port_organics=$buy_organics,port_goods=$buy_goods,port_energy=$buy_energy WHERE port_type='ore' ";
    if ($db->Execute($update) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $update<br />";
        return false;
    }
    echo "- completed successfully. <br />";
    
    echo 'Stocking the Organics ports ';
    $update="UPDATE {$dbtables['universe']} SET port_ore=$buy_ore,port_organics=$sell_organics,port_goods=$buy_goods,port_energy=$buy_energy WHERE port_type='organics' ";
    if ($db->Execute($update) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $update<br />";
        return false;
    }
    echo "- completed successfully. <br />";
    
    echo 'Stocking the Goods ports ';
    $update="UPDATE {$dbtables['universe']} SET port_ore=$buy_ore,port_organics=$buy_organics,port_goods=$sell_goods,port_energy=$buy_energy WHERE port_type='goods' ";
    if ($db->Execute($update) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $update<br />";
        return false;
    }
    echo "- completed successfully. <br />";
    
    echo 'Stocking the Energy ports ';
    $update="UPDATE {$dbtables['universe']} SET port_ore=$buy_ore,port_organics=$buy_organics,port_goods=$buy_goods,port_energy=$sell_energy WHERE port_type='energy' ";
    if ($db->Execute($update) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $update<br />";
        return false;
    }
    echo "- completed successfully. <br />";
    
    return true;
}


function place_planets()
{
    global $db, $dbtables;
    global $default_prod_ore, $default_prod_organics, $default_prod_goods;
    global $default_prod_energy, $default_prod_fighters, $default_prod_torp;
    
    $nump = $_POST['nump'];
    $sector_max = $_POST['sector_max'];
    
    echo "Selecting $nump sectors to place unowned planets in.<br />";
    
    // create array of random numbers, one for each sector
    // the values stored are themselves sector numbers so this
    // is creating a random ordering of the sector numbers,
    // some numbers may repeat and other maybe missing
    for($i=0; $i<=$sector_max; $i++) {
        $num = rand(0, $sector_max - 1);
        $sectors[$i] = $num;
    }
    
    // check the first $nump sectors in array created above if the sector
    // allows planets, add one.
    // NOTE: The original code skipped sectors and everytime a sector was
    // skipped the final number of planets was reduced by one. So changed
    // this to a while loop.
    // This does not check whether or not a sector already has planets.
    // This is how sectors get two planets. In theory, it is possible to
    // end up with sectors that have more than the maximun allowed planets.
    //for($i=0; $i<$nump; $i++) {
    $i = 0;
    $j = 0;
    while (($j<$nump) && ($i<$sector_max)) {
        
        // select sectors where planets are allowed
        $sql  = "SELECT {$dbtables['universe']}.sector_id ";
        $sql .= " FROM  {$dbtables['universe']}, {$dbtables['zones']} ";
        $sql .= " WHERE {$dbtables['universe']}.sector_id={$sectors[$i]} ";
        $sql .= "   AND {$dbtables['zones']}.zone_id={$dbtables['universe']}.zone_id  ";
        $sql .= "   AND {$dbtables['zones']}.allow_planet='N'";
        
        $select = $db->Execute($sql) or die("DB error");
        
        if($select->RecordCount() == 0) {            
            $sql2  = "INSERT INTO {$dbtables['planets']} (colonists, owner, corp, prod_ore, prod_organics, prod_goods, prod_energy, prod_fighters, prod_torp, sector_id) ";
            $sql2 .= " VALUES (2,0,0,$default_prod_ore,$default_prod_organics,$default_prod_goods,$default_prod_energy, $default_prod_fighters, $default_prod_torp,{$sectors[$i]})";
            if ($db->Execute($sql2) == false ) {
                echo "\nError: ".$db->ErrorMsg().'<br />';
                echo "SQL: $sql2<br />";
                return false;
            } else {
                //echo "Adding planet to $sectors[$i] <br /> ";
                $j++;
            }
        } else {
            //echo "Sector $sectors[$i] was skipped<br />";
        }
        $i++;
    }
    echo "Unowned planet placement completed successfully.<br />";
    
    return true;
}

function create_warp_links()
{
    global $db, $dbtables;

    // The value of $loops divdes the universe into continuous blocks of sectors.
    // Warp links are created to link neighboring sectors to each other.
    // The first sector in a section will be linked to the last sector of the
    // section. For example, sector #0 linked to #499 and vice versa.
    
    $loops = $_POST['loops'];
    $sector_max = $_POST['sector_max'];
    $nump = $_POST['nump'];
    
    $loopsize = round($sector_max/$loops); 
    $start = 0;
    $finish = $loopsize - 1;
    for($i=1; $i<=$loops; $i++) {
        echo "<br />Creating loop $i of $loopsize sectors (from sector $start to $finish) ";
        for($j=$start; $j<$finish; $j++) {
            $k = $j + 1;
            $sql = "INSERT INTO {$dbtables['links']} (link_start,link_dest) VALUES ($j,$k), ($k,$j) ";
            if ($db->Execute($sql) == false) {
                echo "\nError: ".$db->ErrorMsg().'<br />';
                echo "SQL: $sql<br />";
                return false;
            }
        }
        $sql = "INSERT INTO $dbtables[links] (link_start,link_dest) VALUES ($start, $finish), ($finish,$start)";
        if ($db->Execute($sql) == false ) {
                echo "\nError: ".$db->ErrorMsg().'<br />';
                echo "SQL: $sql<br />";
                return false;
        }
            
        //echo "$finish<=>$start";
        echo "- loop $i completed successfully.";
        $start=$finish+1;
        $finish=$finish+$loopsize;
        if ($finish>$sector_max) {
            $finish=$sector_max;
        }
    }
    //PrintFlush("<br />Created $loops sector warp-loops (out of $nump sectors) - completed successfully.<br />");

    return true;
}

function create_adjacent_sector_warp_links() 
{
    global $db, $dbtables;
    $sector_max = $_POST['sector_max'];
    
    PrintFlush("<br />Creating warp links between adjacent sectors.");
    //--- specify the number of sectors to do in one batch
    $batch_size = 50;
    $i=0;
    while ($i<$sector_max) {
        
        $insert = "INSERT INTO {$dbtables['links']} (link_start,link_dest) VALUES ";
        $start = $i;
        $finish = $i + $batch_size;
        echo "<br />Working on sectors $start to $finish";

        for ($j=$start; $j<$finish; $j++) {
            $link1 = $j;
            $link2 = $j + 1;
            $insert .= " ($link1,$link2), ($link2,$link1),";
        }
        //--- remove final comma - requires PHP 4.1+
        $sql = chop($insert, ',');
        //--- send insert to db
        if ($db->Execute($sql) == false) {
            echo "\nError: ".$db->ErrorMsg().'<br />';
            echo "SQL: $sql<br />";
            return false;
        }
        //--- continue to next batch of sectors
        $i = $i + $batch_size;
        echo "... completed.";
    }
    return true;
}

function create_random_warp_links() 
{
    global $db, $dbtables;

    $sector_max = $_POST['sector_max'];
    
    PrintFlush("<br />Randomly One-way Linking $i Sectors (out of $sector_max sectors) ");
    $i=0;
    while ($i < ($sector_max-500)) {
        $insert="INSERT INTO {$dbtables['links']} (link_start,link_dest) VALUES ";
        for ($j=1; $j<=499; $j++) {
            $link1=intval(rand(1,$sector_max));
            $link2=intval(rand(1,$sector_max));
            $insert.="($link1,$link2),";
        }
        $link1=intval(rand(1,$sector_max));
        $link2=intval(rand(1,$sector_max));
        $insert.="($link1,$link2);";
        $i=$i+500;
        ### Now lets post the information to the mysql database.
        if ($db->Execute($insert) == false) {
            echo "\nError: ".$db->ErrorMsg().'<br />';
            echo "SQL: $insert<br />";
            return false;
        }

        // PrintFlush("Finished linking $i sectors ( out of $sector_max sectors)...<br />");
    }
    
    //--- Now lets do the remaining sectors.
    $insert="INSERT INTO {$dbtables['links']} (link_start,link_dest) VALUES ";
    for ($j=$i; $j<=$sector_max-1; $j++) {
        $link1=intval(rand(1,$sector_max));
        $link2=intval(rand(1,$sector_max));
        $insert.="($link1,$link2),";
    }
    $link1=intval(rand(1,$sector_max));
    $link2=intval(rand(1,$sector_max));
    $insert.="($link1,$link2);";
    $j=$j+1;
    
    //--- Now lets post the information to the mysql database.
    if ($db->Execute($insert) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $insert<br />";
        return false;
    }
    $i=$j;
    print("");
    PrintFlush("- completed successfully.");
    
    PrintFlush("<br />Randomly Two-way Linking Sectors ");
    $i=0;
    while ($i < ($sector_max-500)) {
        $insert="INSERT INTO $dbtables[links] (link_start,link_dest) VALUES ";
        for ($j=1; $j<=499; $j++) {
            $link1=intval(rand(1,$sector_max));
            $link2=intval(rand(1,$sector_max));
            $insert.="($link1,$link2),";
            $insert.="($link2,$link1),";
        }
        $link1=intval(rand(1,$sector_max));
        $link2=intval(rand(1,$sector_max));
        $insert.="($link1,$link2),";
        $insert.="($link2,$link1);";
        $i=$i+500;
        //--- Now lets post the information to the mysql database.
        if ($db->Execute($insert) == false) {
            echo "\nError: ".$db->ErrorMsg().'<br />';
            echo "SQL: $insert<br />";
            return false;
        }
        // PrintFlush("Finished linking $i sectors ( out of $sector_max sectors)...<br />");
    }
    //--- Now lets do the remaining sectors.
    $insert="INSERT INTO $dbtables[links] (link_start,link_dest) VALUES ";
    for ($j=$i; $j<=$sector_max-1; $j++) {
        $link1=intval(rand(1,$sector_max));
        $link2=intval(rand(1,$sector_max));
        $insert.="($link1,$link2),";
        $insert.="($link2,$link1),";
    }
    $link1=intval(rand(1,$sector_max));
    $link2=intval(rand(1,$sector_max));
    $insert.="($link1,$link2),";
    $insert.="($link2,$link1);";
    $j=$j+1;
    //--- Now lets post the information to the mysql database.
    if ($db->Execute($insert) == false) {
        echo "\nError: ".$db->ErrorMsg().'<br />';
        echo "SQL: $insert<br />";
        return false;
    }
    $i=$j;
    print("");
    PrintFlush("- completed successfully. <br />");
  
    return true;
}

function configure_scheduler() 
{
    global $db, $dbtables;
    global $sched_apocalypse, $sched_degrade, $sched_IGB, $sched_news, $sched_planets;
    global $sched_ports, $sched_ranking, $sched_ticks, $sched_turns;
    
    echo "<br /><h3>Configuring game scheduler</h3><br />";
    
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_turns, 0, 'sched_turns.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_turns, 0, 'sched_defenses.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_turns, 0, 'sched_furangee.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_IGB, 0, 'sched_IGB.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_news, 0, 'sched_news.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_planets, 0, 'sched_planets.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_ports, 0, 'sched_ports.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_turns, 0, 'sched_tow.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_ranking, 0, 'sched_ranking.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_degrade, 0, 'sched_degrade.php', '',unix_timestamp(now()))";
    $sql[] = "INSERT INTO {$dbtables['scheduler']} VALUES('', 'Y', 0, $sched_apocalypse, 0, 'sched_apocalypse.php', '',unix_timestamp(now()))";
    
    for ($i=0; $i<count($sql); $i++) {
        if ($db->Execute($sql[$i]) == false ) {
                echo "\nError: ".$db->ErrorMsg().'<br />';
                echo "SQL: $sql[$i]<br />";
                return false;
        }
    }
    
    echo "
    <br />Update ticks will occur every $sched_ticks minutes<br />
    Turns will occur every $sched_turns minutes.<br />
    Defenses will be checked every $sched_turns minutes.<br />
    Furangees will play every $sched_turns minutes.<br />
    Interests on IGB accounts will be accumulated every $sched_IGB minutes.<br />
    News will be generated every $sched_news minutes.<br />
    Planets will generate production every $sched_planets minutes.<br />
    Ports will regenerate every $sched_ports minutes.<br />
    Ships will be towed from fed sectors every $sched_turns minutes.<br />
    Rankings will be generated every $sched_ranking minutes.<br />
    Sector Defences will degrade every $sched_degrade minutes.<br />
    The planetary apocalypse will occur every $sched_apocalypse minutes.<br />
    ";
    
    return true;
}

function setup_admin_account()
{
    global $db, $dbtables;
    global $admin_mail, $maxlen_password, $default_lang;
    global $start_armour, $start_credits, $start_energy, $start_fighters, $start_turns;
    
    echo "Setting up the admin account<br />";
    $password = substr($admin_mail, 0, $maxlen_password);
    $stamp=date("Y-m-d H:i:s");

    $sql[] = "INSERT INTO {$dbtables['ibank_accounts']} (ship_id,balance,loan) VALUES (1,0,0)";
    $sql[] = "INSERT INTO {$dbtables['ships']} VALUES('','WebMaster','N','WebMaster','$password','$admin_mail',0,0,0,0,0,0,0,0,0,0,$start_armour,0,$start_credits,0,0,0,0,$start_energy,0,$start_fighters,$start_turns,'','N',0,1,0,0,'N','N',0,0, '$stamp',0,0,0,0,'N','1.1.1.1',0,0,0,0,'Y','N','N','Y',' ','$default_lang', 'Y','N')";
    $sql[] = "INSERT INTO {$dbtables['zones']} VALUES('','WebMaster\'s Territory', 1, 'N', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 0)";
    for ($i=0; $i<3; $i++) {
        if ($db->Execute($sql[$i]) == false ) {
                echo "\nError: ".$db->ErrorMsg().'<br />';
                echo "SQL: $sql[$i]<br />";
                return false;
        }
    }
    
    echo "
    <br /><br />
    <b>Your admin login is: <br /><br />
    Username: $admin_mail<br />
    Password: $password
    <br /></b>
    <br />NOTE: Change your password when you login for the first time.
    ";
    
    return true;
}

// ------ End defining functions 

?>
